import 'package:flutter/material.dart';
import 'package:intl/intl.dart';

import '../base_view.dart';
import '../shared_class.dart';

class TimeStreamListner extends StatefulWidget {

  final Color textColor;
  final Color widgetBackColor;
  final Color  listBackColor;
  final Color widgetUnselectedColor;
  final double widgetHeight;
  final double widgetWidth;
  final double containerHeight;
  final double containerWidth;
  final double expandWidth;
  final Function clickCallBack;
  final Function timeCallBack;
  final typesofCalendar passingString;
  final bool is24Hours;

  TimeStreamListner(
      this.textColor,
      this.widgetBackColor,
      this.listBackColor,
      this.widgetUnselectedColor,
      this.widgetHeight,
      this.widgetWidth,
      this.containerHeight,
      this.containerWidth,
      this.expandWidth,this.clickCallBack,this.timeCallBack,this.passingString,this.is24Hours);

  @override
  _TimeStreamListnerState createState() => _TimeStreamListnerState();
}

class _TimeStreamListnerState extends State<TimeStreamListner> {
  @override
  Widget build(BuildContext context) {
    return Container(
      height: widget.containerHeight,
      margin: EdgeInsets.all(10),
      color: Colors.transparent,
      child: widget.passingString == typesofCalendar.hours ? hoursStreamBuilder(widget):minuteStreamBuilder(widget),
    );

  }
}
//LISTEN THE SELECTED MINUTES
Widget minuteStreamBuilder(widget){
  return StreamBuilder(
      stream: SharedClass.minuteIndex.stream,
      builder: (context, snapshot) {
        if (snapshot.hasData) {
          return BaseView(
              widget.textColor,
              widget.widgetBackColor,
              widget.listBackColor,
              widget.widgetUnselectedColor,
              null,
              widget.containerHeight,
              widget.containerWidth,
              widget.widgetWidth,
              widget.widgetHeight,
              10,snapshot.data,true,
              widget.expandWidth,widget.clickCallBack,widget.timeCallBack,widget.passingString,widget.is24Hours);
        } else {
          return BaseView(
              widget.textColor,
              widget.widgetBackColor,
              widget.listBackColor,
              widget.widgetUnselectedColor,
              null,
              widget.containerHeight,
              widget.containerWidth,
              widget.widgetWidth,
              widget.widgetHeight,
              10,DateTime.now().minute,true,
              widget.expandWidth,widget.clickCallBack,widget.timeCallBack,widget.passingString,widget.is24Hours);
        }
      });
}
//LISTEN THE SELECTED HOURS
Widget hoursStreamBuilder(widget){
  var hoursValue;
  if(widget.is24Hours){
    hoursValue = DateFormat("H").format(DateTime.now());

  }else{
    hoursValue = DateFormat("h").format(DateTime.now());
  }

  return StreamBuilder(

      stream: SharedClass.hoursIndex.stream,
      builder: (context, snapshot) {
        if (snapshot.hasData) {
          return BaseView(
              widget.textColor,
              widget.widgetBackColor,
              widget.listBackColor,
              widget.widgetUnselectedColor,
              null,
              widget.containerHeight,
              widget.containerWidth,
              widget.widgetWidth,
              widget.widgetHeight,
              10,snapshot.data,true,
              widget.expandWidth,widget.clickCallBack,widget.timeCallBack,widget.passingString,widget.is24Hours);
        } else {
          return BaseView(
              widget.textColor,
              widget.widgetBackColor,
              widget.listBackColor,
              widget.widgetUnselectedColor,
              null,
              widget.containerHeight,
              widget.containerWidth,
              widget.widgetWidth,
              widget.widgetHeight,
              10,int.parse(hoursValue),true,
              widget.expandWidth,widget.clickCallBack,widget.timeCallBack,widget.passingString,widget.is24Hours);
        }
      });
}
